// VisionServerDlg.h : wb_[ t@C
//

#pragma once
#include "afxwin.h"
#include "Network/Network.h"
#include "MarkerDetector/MarkerDetector.h"
#include "Capture/Capture.h"

#include <cv.h>
#include <highgui.h>
#pragma comment(lib,"cv200.lib")
#pragma comment(lib,"cxcore200.lib")
#pragma comment(lib,"highgui200.lib")


#include <vector>
#include "afxcmn.h"

//#pragma comment(lib,"../common/ImageCapture/videoInput.lib")
//#pragma comment(linker,"/NODEFAULTLIB:atlthunk")

#pragma comment(lib,"libAR.lib")
#pragma comment(lib,"libARgsub.lib")
#pragma comment(linker,"/NODEFAULTLIB:libcmt.lib")


// CVisionServerDlg _CAO
class CVisionServerDlg : public CDialog
{
// RXgNV
public:
	CVisionServerDlg(CWnd* pParent = NULL);	// WRXgN^

// _CAO f[^
	enum { IDD = IDD_VISIONSERVER_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV T|[g


// 
protected:
	HICON m_hIcon;

	// ꂽAbZ[W蓖Ċ֐
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()

public:
	afx_msg void OnBnClickedOk();
	afx_msg void OnBnClickedCancel();
	BOOL PreTranslateMessage(MSG* pMsg);
	afx_msg void OnBnClickedButtonStop();
	afx_msg void OnBnClickedButtonStart();

	int LoadConfigFile( const char* filename );

	void LockInterface();
	void UnlockInterface();

	static UINT Thread(LPVOID pParam);
	void Thread();
	CWinThread* m_pThread;
	BOOL m_loopEnable;

	static UINT PattCapThread(LPVOID pParam);
	void PattCapThread();
	CWinThread* m_pPattCapThread;
	BOOL m_PattCapLoopEnable;

	Network m_net;
	CButton m_button_start;
	CButton m_button_stop;
	int m_edit_port;
	CEdit m_cntl_edit_port;

//	CvCapture *m_camera;

	Capture m_capture;

	int m_combo_camera_id;
	int m_combo_image_size;
	int m_max_camera_num;
	CComboBox m_cntl_combo_camera_id;
	CComboBox m_cntl_combo_image_size;

	vector<PATTERN_DATA> m_pattern_list;
	vector<CvSize> m_size_list;

	int m_radio_dataflow;
	BOOL m_check_name;
	BOOL m_check_pos2d;
	BOOL m_check_dvec;
	BOOL m_check_pos3d;
	BOOL m_check_glmatrix;
	BOOL m_check_vertex;
	BOOL m_check_area;
	BOOL m_check_cf;
	CStatic m_cntl_data_format;
	CButton m_cntl_check_name;
	CButton m_cntl_check_pos2d;
	CButton m_cntl_check_dvec;
	CButton m_cntl_check_pos3d;
	CButton m_cntl_check_glmatrix;
	CButton m_cntl_check_vertex;
	CButton m_cntl_check_area;
	CButton m_cntl_check_cf;
	CString m_edit_data_format;
	int MakeDataFormat(void);
	afx_msg void OnBnClickedCheckName();
	afx_msg void OnBnClickedCheckPos2d();
	afx_msg void OnBnClickedCheckDvec();
	afx_msg void OnBnClickedCheckPos3d();
	afx_msg void OnBnClickedCheckArea();
	afx_msg void OnBnClickedCheckCf();
	afx_msg void OnBnClickedCheckVertex();
	afx_msg void OnBnClickedCheckGlmatrix();
	CButton m_cntl_radio_dataflow1;
	CButton m_cntl_radio_dataflow2;
	CListCtrl m_cntl_list_pattern;
	CButton m_cntl_button_patt_capture;


	afx_msg int InitList(void);
	afx_msg int InsertItemToList(PATTERN_DATA pattData);
	afx_msg void DeleteItemFromList(void);

	afx_msg void OnNMRClickListPattern(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg int EnableServer(void);
	afx_msg int DisableServer(void);
	afx_msg void OnBnClickedButtonStartPatternCapture();
	afx_msg void OnLvnItemchangedListPattern(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void ShowImage( int nID, IplImage *image );

	afx_msg int SavePatternList( const char * filename );
	afx_msg int SaveConfigFile( const char * filename );

	IplImage *m_imgPatt;
	CEdit m_cntl_edit_patt_name;
	CEdit m_cntl_edit_patt_width;
	double m_edit_patt_width;
	CString m_edit_patt_name;
	afx_msg void OnBnClickedButtonSavePatternInfo();
	BOOL m_check_preview;
	CButton m_cntl_check_preview;
	CButton m_cntl_button_save_patt_info;
	CEdit m_cntl_edit_output;
	CString m_edit_output;

	double	m_default_patt_width;
	CString m_edit_IP_address;
};
